<template>
  <div
    ref="stickyDetail"
    class="detail-farmer__profile"
    v-on:scroll='handleScroll'
    v-bind:style="{width: width + 'px'}"
    :class="sticky ? 'sticky': ''"
  >
    <header>
      <h4>Profile Petani</h4>
    </header>
    <section v-if="this.farmer">
      <label>Nama Petani</label>
      <p>{{this.farmer.farmer_name}}</p>
      <label>Status</label>
      <div class="btn-wrapper">
        <div class="btn">{{this.farmer.farmer_status.status}}</div>
      </div>
      <label>Tg. Register</label>
      <p>{{toDate(this.farmer.created_at)}}</p>
      <label>Tanggal Lahir</label>
      <p>{{toDate(this.farmer.date_of_birth)}}</p>
      <label>Jenis Kelamin</label>
      <p>{{this.farmer.gender == 0 ? "Laki-Laki" : "Wanita"}}</p>
      <label>No Telepon</label>
      <p>{{this.farmer.telp_number}}</p>
      <label>Alamat</label>
      <p>{{this.farmer.address}}, {{this.farmer.sub_region}}, {{this.farmer.region}}, {{this.farmer.city.city_name}}, {{this.farmer.province.province_name}}</p>
    </section>
  </div>
</template>

<script>
import moment from 'moment'

export default {
  name: 'Detail',
  data() {
    return {
      sticky: false,
      width: '100%'
    }
  },
  mounted() {
    document.addEventListener('scroll', this.handleScroll)
    this.width = this.$refs.stickyDetail.clientWidth || '100%';
  },
  destroyed() {
    window.removeEventListener('scroll', this.handleScroll);
  },
  methods: {
    handleScroll: function(e) {
      if ((window.scrollY) > 100) {
        if (!this.sticky) {
          this.sticky = true;
        }
      } else {
        if (this.sticky) {
          this.sticky = false;
        }
      }
    },
    toDate(value) {
      return moment(String(value)).format('DD MMMM YYYY')
    }
  },
  computed: {
    farmer: {
      get: function() {
        return this.$store.state.farmer.detail.farmer;
      }
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  @import '@/styles/variables.scss';
  @import '@/styles/mixin.scss';
  .detail-farmer {
    &__profile {
      border-radius: 8px;
      box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.18);
      background-color: #ffffff;

      .btn {
        height: 32px;
        border-radius: 16px;
        background-color: #73bd40;
        padding: 0 20px;
        color: white;
        font-weight: bold;
        display: inline-flex;
        justify-content: center;
        align-items: center;
      }
      .btn-wrapper {
        margin: 10px 0 20px 0;
      }
    }

    .sticky {
      position: fixed;
      width: 300px;
      top: 20px;
    }

    header, section {
      padding: 20px;
    }

    header {
      border-bottom: solid 1px $ritx-light-grey;
    }

    h4 {
      @include ritx-bold;
      font-size: 18px;
      color: $ritx-dark-green;
    }

    label {
      @include ritx-bold;
      color: $ritx-dark-green;
    }

    p {
      font-size: 16px;
      @include ritx-normal-font;
      margin-bottom: 20px;
      color: $ritx-dark-grey;
    }
  }
  </style>
